'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _bluebird;

function _load_bluebird() {
  return _bluebird = require('bluebird');
}

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _envExtension;

function _load_envExtension() {
  return _envExtension = _interopRequireDefault(require('./env-extension'));
}

var _baseExtension;

function _load_baseExtension() {
  return _baseExtension = _interopRequireDefault(require('./base-extension'));
}

var _objects;

function _load_objects() {
  return _objects = require('../scope/objects');
}

var _logger;

function _load_logger() {
  return _logger = _interopRequireDefault(require('../logger/logger'));
}

var _constants;

function _load_constants() {
  return _constants = require('../constants');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TesterExtension = function (_EnvExtension) {
  _inherits(TesterExtension, _EnvExtension);

  function TesterExtension(extensionProps) {
    _classCallCheck(this, TesterExtension);

    extensionProps.envType = (_constants || _load_constants()).TESTER_ENV_TYPE;

    var _this = _possibleConstructorReturn(this, (TesterExtension.__proto__ || Object.getPrototypeOf(TesterExtension)).call(this, extensionProps));

    _this.envType = extensionProps.envType;
    return _this;
  }

  _createClass(TesterExtension, [{
    key: 'toModelObject',
    value: function toModelObject() {
      (_logger || _load_logger()).default.debug('tester-extension', 'toModelObject');
      var envModelObject = _get(TesterExtension.prototype.__proto__ || Object.getPrototypeOf(TesterExtension.prototype), 'toModelObject', this).call(this);
      var modelObject = _extends({}, envModelObject);
      return modelObject;
    }

    /**
     * Loading from props (usually from bit.json)
     * @param {*} props
     */

  }], [{
    key: 'load',
    value: function () {
      var _ref = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(props) {
        var envExtensionProps, extension, throws;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                (_logger || _load_logger()).default.debug('tester-extension', 'load');
                props.envType = (_constants || _load_constants()).TESTER_ENV_TYPE;
                // Throw error if tester not loaded
                props.throws = true;
                _context.next = 5;
                return _get(TesterExtension.__proto__ || Object.getPrototypeOf(TesterExtension), 'load', this).call(this, props);

              case 5:
                envExtensionProps = _context.sent;
                extension = new TesterExtension(envExtensionProps);

                if (!extension.loaded) {
                  _context.next = 11;
                  break;
                }

                throws = true;
                _context.next = 11;
                return extension.init(throws);

              case 11:
                return _context.abrupt('return', extension);

              case 12:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function load(_x) {
        return _ref.apply(this, arguments);
      }

      return load;
    }()
  }, {
    key: 'loadFromModelObject',
    value: function () {
      var _ref2 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee2(modelObject, repository
      // $FlowFixMe
      ) {
        var actualObject, envExtensionProps, extension;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                (_logger || _load_logger()).default.debug('tester-extension', 'loadFromModelObject');

                if (modelObject) {
                  _context2.next = 3;
                  break;
                }

                return _context2.abrupt('return', undefined);

              case 3:
                actualObject = typeof modelObject === 'string' ? _extends({ envType: (_constants || _load_constants()).TESTER_ENV_TYPE }, (_baseExtension || _load_baseExtension()).default.transformStringToModelObject(modelObject)) : _extends({ envType: (_constants || _load_constants()).TESTER_ENV_TYPE }, modelObject);
                _context2.next = 6;
                return _get(TesterExtension.__proto__ || Object.getPrototypeOf(TesterExtension), 'loadFromModelObject', this).call(this, actualObject, repository);

              case 6:
                envExtensionProps = _context2.sent;
                extension = new TesterExtension(envExtensionProps);
                return _context2.abrupt('return', extension);

              case 9:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this);
      }));

      function loadFromModelObject(_x2, _x3) {
        return _ref2.apply(this, arguments);
      }

      return loadFromModelObject;
    }()
  }]);

  return TesterExtension;
}((_envExtension || _load_envExtension()).default);

exports.default = TesterExtension;