'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});


/**
 * schema for resolve conflict
 */
exports.default = {
  properties: {
    mergeStrategy: {
      required: true,
      description: `enter resolve-conflict strategy option:
o (ours) to use the current modified files
t (theirs) to use the specified version (and override the modification)
m (manual) to merge the modified files with the specified version and leave the files in a conflict state
`,
      message: 'please use the following options only: o, t or m',
      type: 'string',
      conform(value) {
        value = value.toLowerCase();
        var options = ['o', 't', 'm'];
        return options.includes(value);
      }
    }
  }
};