'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _regenerator;

function _load_regenerator() {
  return _regenerator = _interopRequireDefault(require('babel-runtime/regenerator'));
}

var _bluebird;

function _load_bluebird() {
  return _bluebird = require('bluebird');
}

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _utils;

function _load_utils() {
  return _utils = require('../../utils');
}

var _objects;

function _load_objects() {
  return _objects = require('../objects');
}

var _componentObjects;

function _load_componentObjects() {
  return _componentObjects = _interopRequireDefault(require('../component-objects'));
}

var _constants;

function _load_constants() {
  return _constants = require('../../constants');
}

var _exceptions;

function _load_exceptions() {
  return _exceptions = require('../exceptions');
}

var _models;

function _load_models() {
  return _models = require('../models');
}

var _bitId;

function _load_bitId() {
  return _bitId = require('../../bit-id');
}

var _globalConfig;

function _load_globalConfig() {
  return _globalConfig = _interopRequireWildcard(require('../../api/consumer/lib/global-config'));
}

var _logger;

function _load_logger() {
  return _logger = _interopRequireDefault(require('../../logger/logger'));
}

var _repository;

function _load_repository() {
  return _repository = _interopRequireDefault(require('../objects/repository'));
}

var _abstractVinyl;

function _load_abstractVinyl() {
  return _abstractVinyl = _interopRequireDefault(require('../../consumer/component/sources/abstract-vinyl'));
}

var _manipulateDir;

function _load_manipulateDir() {
  return _manipulateDir = require('../../consumer/component-ops/manipulate-dir');
}

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var SourceRepository = function () {
  function SourceRepository(scope) {
    _classCallCheck(this, SourceRepository);

    this.scope = scope;
  }

  _createClass(SourceRepository, [{
    key: 'objects',
    value: function objects() {
      return this.scope.objects;
    }
  }, {
    key: 'getMany',
    value: function getMany(ids) {
      var _this = this;

      (_logger || _load_logger()).default.debug(`sources.getMany, Ids: ${ids.join(', ')}`);
      return Promise.all(ids.map(function (id) {
        return _this.get(id).then(function (component) {
          return {
            id,
            component
          };
        });
      }));
    }
  }, {
    key: 'get',
    value: function () {
      var _ref = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee(bitId) {
        var component, foundComponent, msg, version;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                component = (_models || _load_models()).ModelComponent.fromBitId(bitId);
                _context.next = 3;
                return this._findComponent(component);

              case 3:
                foundComponent = _context.sent;

                if (!(foundComponent && bitId.hasVersion())) {
                  _context.next = 15;
                  break;
                }

                // $FlowFixMe
                msg = `found ${bitId.toStringWithoutVersion()}, however version ${bitId.getVersion().versionNum}`;
                // $FlowFixMe

                if (foundComponent.versions[bitId.version]) {
                  _context.next = 9;
                  break;
                }

                (_logger || _load_logger()).default.debug(`${msg} is not in the component versions array`);
                return _context.abrupt('return', null);

              case 9:
                _context.next = 11;
                return this.objects().findOne(foundComponent.versions[bitId.version]);

              case 11:
                version = _context.sent;

                if (version) {
                  _context.next = 15;
                  break;
                }

                (_logger || _load_logger()).default.debug(`${msg} object was not found on the filesystem`);
                return _context.abrupt('return', null);

              case 15:
                return _context.abrupt('return', foundComponent);

              case 16:
              case 'end':
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      function get(_x) {
        return _ref.apply(this, arguments);
      }

      return get;
    }()
  }, {
    key: '_findComponent',
    value: function () {
      var _ref2 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee2(component) {
        var foundComponent;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.prev = 0;
                _context2.next = 3;
                return this.objects().findOne(component.hash());

              case 3:
                foundComponent = _context2.sent;

                if (!(foundComponent instanceof (_models || _load_models()).Symlink)) {
                  _context2.next = 6;
                  break;
                }

                return _context2.abrupt('return', this._findComponentBySymlink(foundComponent));

              case 6:
                if (!foundComponent) {
                  _context2.next = 8;
                  break;
                }

                return _context2.abrupt('return', foundComponent);

              case 8:
                _context2.next = 13;
                break;

              case 10:
                _context2.prev = 10;
                _context2.t0 = _context2['catch'](0);

                (_logger || _load_logger()).default.error(`findComponent got an error ${_context2.t0}`);

              case 13:
                (_logger || _load_logger()).default.debug(`failed finding a component ${component.id()} with hash: ${component.hash().toString()}`);
                return _context2.abrupt('return', null);

              case 15:
              case 'end':
                return _context2.stop();
            }
          }
        }, _callee2, this, [[0, 10]]);
      }));

      function _findComponent(_x2) {
        return _ref2.apply(this, arguments);
      }

      return _findComponent;
    }()
  }, {
    key: '_findComponentBySymlink',
    value: function () {
      var _ref3 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee3(symlink) {
        var realComponentId, realModelComponent, foundComponent;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                realComponentId = symlink.getRealComponentId();
                realModelComponent = (_models || _load_models()).ModelComponent.fromBitId(realComponentId);
                _context3.next = 4;
                return this.objects().findOne(realModelComponent.hash());

              case 4:
                foundComponent = _context3.sent;

                if (foundComponent) {
                  _context3.next = 7;
                  break;
                }

                throw new Error(`error: found a symlink object "${symlink.id()}" that references to a non-exist component "${realComponentId.toString()}".
if you have the steps to reproduce the issue, please open a Github issue with the details.
to quickly fix the issue, please delete the object at "${this.objects().objectPath(symlink.hash())}"`);

              case 7:
                return _context3.abrupt('return', foundComponent);

              case 8:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this);
      }));

      function _findComponentBySymlink(_x3) {
        return _ref3.apply(this, arguments);
      }

      return _findComponentBySymlink;
    }()
  }, {
    key: 'getObjects',
    value: function getObjects(id) {
      var _this2 = this;

      return this.get(id).then(function (component) {
        if (!component) throw new (_exceptions || _load_exceptions()).ComponentNotFound(id.toString());
        return component.collectObjects(_this2.objects());
      });
    }
  }, {
    key: 'findOrAddComponent',
    value: function findOrAddComponent(props) {
      var comp = (_models || _load_models()).ModelComponent.from(props);
      return this._findComponent(comp).then(function (component) {
        if (!component) return comp;
        return component;
      });
    }
  }, {
    key: 'modifyCIProps',
    value: function modifyCIProps(_ref4) {
      var source = _ref4.source,
          ciProps = _ref4.ciProps;

      var objectRepo = this.objects();

      return this.findOrAddComponent(source).then(function (component) {
        return component.loadVersion(component.latest(), objectRepo).then(function (version) {
          version.setCIProps(ciProps);
          return objectRepo._writeOne(version);
        });
      });
    }
  }, {
    key: 'modifySpecsResults',
    value: function modifySpecsResults(_ref5) {
      var source = _ref5.source,
          specsResults = _ref5.specsResults;

      var objectRepo = this.objects();

      return this.findOrAddComponent(source).then(function (component) {
        return component.loadVersion(component.latest(), objectRepo).then(function (version) {
          version.setSpecsResults(specsResults);
          return objectRepo._writeOne(version);
        });
      });
    }

    // TODO: This should treat dist as an array

  }, {
    key: 'updateDist',
    value: function updateDist(_ref6) {
      var source = _ref6.source;

      var objectRepo = this.objects();

      return this.findOrAddComponent(source).then(function (component) {
        return component.loadVersion(component.latest(), objectRepo).then(function (version) {
          var dist = source.dist ? (_models || _load_models()).Source.from((0, (_utils || _load_utils()).bufferFrom)(source.dist.toString())) : null;
          version.setDist(dist);
          objectRepo.add(dist).add(version);
          return objectRepo.persist();
        });
      });
    }

    /**
     * given a consumer-component object, returns the Version representation.
     * useful for saving into the model or calculation the hash for comparing with other Version object.
     * among other things, it reverts the path manipulation that was done when a component was loaded
     * from the filesystem. it adds the originallySharedDir and strip the wrapDir.
     *
     * warning: Do not change anything on the consumerComponent instance! Only use its clone.
     *
     * @see model-components.toConsumerComponent() for the opposite action. (converting Version to
     * ConsumerComponent).
     */

  }, {
    key: 'consumerComponentToVersion',
    value: function () {
      var _ref7 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee4(_ref8) {
        var consumerComponent = _ref8.consumerComponent,
            consumer = _ref8.consumer,
            versionFromModel = _ref8.versionFromModel,
            message = _ref8.message,
            flattenedDependencies = _ref8.flattenedDependencies,
            flattenedDevDependencies = _ref8.flattenedDevDependencies,
            flattenedCompilerDependencies = _ref8.flattenedCompilerDependencies,
            flattenedTesterDependencies = _ref8.flattenedTesterDependencies,
            specsResults = _ref8.specsResults;

        var clonedComponent, setEol, manipulateDirs, files, dists, compilerFiles, testerFiles, _ref9, _ref10, username, email, version;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                // $FlowFixMe
                clonedComponent = consumerComponent.clone();

                setEol = function setEol(files) {
                  if (!files) return;
                  var result = files.map(function (file) {
                    file.file = file.toSourceAsLinuxEOL();
                    return file;
                  });
                  return result;
                };

                manipulateDirs = function manipulateDirs(pathStr) {
                  return (0, (_manipulateDir || _load_manipulateDir()).revertDirManipulationForPath)(pathStr, clonedComponent.originallySharedDir, clonedComponent.wrapDir);
                };

                files = consumerComponent.files.map(function (file) {
                  return {
                    name: file.basename,
                    relativePath: manipulateDirs(file.relative),
                    file: file.toSourceAsLinuxEOL(),
                    test: file.test
                  };
                });
                dists = clonedComponent.dists.toDistFilesModel(consumer, consumerComponent.originallySharedDir, consumerComponent.compiler);
                compilerFiles = setEol((_ramda || _load_ramda()).default.path(['compiler', 'files'], consumerComponent));
                testerFiles = setEol((_ramda || _load_ramda()).default.path(['tester', 'files'], consumerComponent));
                _context4.next = 9;
                return Promise.all([(_globalConfig || _load_globalConfig()).get((_constants || _load_constants()).CFG_USER_NAME_KEY), (_globalConfig || _load_globalConfig()).get((_constants || _load_constants()).CFG_USER_EMAIL_KEY)]);

              case 9:
                _ref9 = _context4.sent;
                _ref10 = _slicedToArray(_ref9, 2);
                username = _ref10[0];
                email = _ref10[1];


                clonedComponent.mainFile = manipulateDirs(clonedComponent.mainFile);
                clonedComponent.getAllDependencies().forEach(function (dependency) {
                  // ignoreVersion because when persisting the tag is higher than currently exist in .bitmap
                  var depFromBitMap = consumer.bitMap.getComponentIfExist(dependency.id, { ignoreVersion: true });
                  dependency.relativePaths.forEach(function (relativePath) {
                    if (!relativePath.isCustomResolveUsed) {
                      // for isCustomResolveUsed it was never stripped
                      relativePath.sourceRelativePath = manipulateDirs(relativePath.sourceRelativePath);
                      if (depFromBitMap && depFromBitMap.origin === (_constants || _load_constants()).COMPONENT_ORIGINS.IMPORTED) {
                        // when a dependency is imported directly, we need to also change the
                        // destinationRelativePath, which is the path written in the link file, however, the
                        // dir manipulation should be according to this dependency component, not the
                        // consumerComponent passed to this function
                        relativePath.destinationRelativePath = (0, (_manipulateDir || _load_manipulateDir()).revertDirManipulationForPath)(relativePath.destinationRelativePath, depFromBitMap.originallySharedDir, depFromBitMap.wrapDir);
                      }
                    }
                  });
                });
                version = (_models || _load_models()).Version.fromComponent({
                  component: clonedComponent,
                  versionFromModel,
                  files,
                  dists,
                  flattenedDependencies,
                  flattenedDevDependencies,
                  flattenedCompilerDependencies,
                  flattenedTesterDependencies,
                  specsResults,
                  message,
                  username,
                  email
                });
                // $FlowFixMe it's ok to override the pendingVersion attribute

                consumerComponent.pendingVersion = version; // helps to validate the version against the consumer-component

                return _context4.abrupt('return', { version, files, dists, compilerFiles, testerFiles });

              case 18:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this);
      }));

      function consumerComponentToVersion(_x4) {
        return _ref7.apply(this, arguments);
      }

      return consumerComponentToVersion;
    }()
  }, {
    key: 'addSource',
    value: function () {
      var _ref11 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee5(_ref12) {
        var source = _ref12.source,
            consumer = _ref12.consumer,
            flattenedDependencies = _ref12.flattenedDependencies,
            flattenedDevDependencies = _ref12.flattenedDevDependencies,
            flattenedCompilerDependencies = _ref12.flattenedCompilerDependencies,
            flattenedTesterDependencies = _ref12.flattenedTesterDependencies,
            message = _ref12.message,
            exactVersion = _ref12.exactVersion,
            releaseType = _ref12.releaseType,
            specsResults = _ref12.specsResults;

        var objectRepo, component, versionRef, versionFromModel, _ref13, version, files, dists, compilerFiles, testerFiles;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                objectRepo = this.objects();

                // if a component exists in the model, add a new version. Otherwise, create a new component on the model

                _context5.next = 3;
                return this.findOrAddComponent(source);

              case 3:
                component = _context5.sent;

                // TODO: instead of doing that like this we should use:
                // const versionFromModel = await component.loadVersion(source.usedVersion, this.scope.objects);
                // it looks like it's exactly the same code but it's not working from some reason
                versionRef = component.versions[source.usedVersion];
                versionFromModel = void 0;

                if (!versionRef) {
                  _context5.next = 10;
                  break;
                }

                _context5.next = 9;
                return this.scope.getObject(versionRef.hash);

              case 9:
                versionFromModel = _context5.sent;

              case 10:
                _context5.next = 12;
                return this.consumerComponentToVersion({
                  consumerComponent: source,
                  consumer,
                  versionFromModel,
                  message,
                  flattenedDependencies,
                  flattenedDevDependencies,
                  flattenedCompilerDependencies,
                  flattenedTesterDependencies,
                  specsResults
                });

              case 12:
                _ref13 = _context5.sent;
                version = _ref13.version;
                files = _ref13.files;
                dists = _ref13.dists;
                compilerFiles = _ref13.compilerFiles;
                testerFiles = _ref13.testerFiles;

                component.addVersion(version, releaseType, exactVersion);
                objectRepo.add(version).add(component);

                files.forEach(function (file) {
                  return objectRepo.add(file.file);
                });
                if (dists) dists.forEach(function (dist) {
                  return objectRepo.add(dist.file);
                });
                if (compilerFiles) compilerFiles.forEach(function (file) {
                  return objectRepo.add(file.file);
                });
                if (testerFiles) testerFiles.forEach(function (file) {
                  return objectRepo.add(file.file);
                });

                return _context5.abrupt('return', component);

              case 25:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function addSource(_x5) {
        return _ref11.apply(this, arguments);
      }

      return addSource;
    }()
  }, {
    key: 'putAdditionalVersion',
    value: function () {
      var _ref14 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee6(component, version, message) {
        var releaseType = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : (_constants || _load_constants()).DEFAULT_BIT_RELEASE_TYPE;

        var _ref15, _ref16, username, email;

        return (_regenerator || _load_regenerator()).default.wrap(function _callee6$(_context6) {
          while (1) {
            switch (_context6.prev = _context6.next) {
              case 0:
                _context6.next = 2;
                return Promise.all([(_globalConfig || _load_globalConfig()).get((_constants || _load_constants()).CFG_USER_NAME_KEY), (_globalConfig || _load_globalConfig()).get((_constants || _load_constants()).CFG_USER_EMAIL_KEY)]);

              case 2:
                _ref15 = _context6.sent;
                _ref16 = _slicedToArray(_ref15, 2);
                username = _ref16[0];
                email = _ref16[1];

                version.log = {
                  message,
                  username,
                  email,
                  date: Date.now().toString()
                };
                component.addVersion(version, releaseType);
                return _context6.abrupt('return', this.put({ component, objects: [version] }));

              case 9:
              case 'end':
                return _context6.stop();
            }
          }
        }, _callee6, this);
      }));

      function putAdditionalVersion(_x6, _x7, _x8) {
        return _ref14.apply(this, arguments);
      }

      return putAdditionalVersion;
    }()
  }, {
    key: 'put',
    value: function put(_ref17) {
      var component = _ref17.component,
          objects = _ref17.objects;

      (_logger || _load_logger()).default.debug(`sources.put, id: ${component.id()}, versions: ${component.listVersions().join(', ')}`);
      var repo = this.objects();
      repo.add(component);

      var isObjectShouldBeAdded = function isObjectShouldBeAdded(obj) {
        // don't add a component if it's already exist locally with more versions
        if (obj instanceof (_models || _load_models()).ModelComponent) {
          var loaded = repo.loadSync(obj.hash(), false);
          if (loaded) {
            if (Object.keys(loaded.versions) > Object.keys(obj.versions)) {
              return false;
            }
          }
        }
        return true;
      };

      objects.forEach(function (obj) {
        if (isObjectShouldBeAdded(obj)) repo.add(obj);
      });
      return component;
    }

    /**
     * remove specified component versions from component.
     * if all versions of a component were deleted, delete also the component.
     * it doesn't persist anything to the filesystem.
     * (repository.persist() needs to be called at the end of the operation)
     */

  }, {
    key: 'removeComponentVersions',
    value: function removeComponentVersions(component, versions) {
      (_logger || _load_logger()).default.debug(`removeComponentVersion, component ${component.id()}, versions ${versions.join(', ')}`);
      var objectRepo = this.objects();
      versions.forEach(function (version) {
        var ref = component.removeVersion(version);
        objectRepo.removeObject(ref);
      });

      if (component.versionArray.length) {
        objectRepo.add(component); // add the modified component object
      } else {
        // if all versions were deleted, delete also the component itself from the model
        objectRepo.removeObject(component.hash());
      }
    }

    /**
     * @see this.removeComponent()
     *
     */

  }, {
    key: 'removeComponentById',
    value: function () {
      var _ref18 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee7(bitId) {
        var deepRemove = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
        var component;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                (_logger || _load_logger()).default.debug(`sources.removeComponentById: ${bitId.toString()}, deepRemove: ${deepRemove.toString()}`);
                _context7.next = 3;
                return this.get(bitId);

              case 3:
                component = _context7.sent;

                if (component) {
                  _context7.next = 6;
                  break;
                }

                return _context7.abrupt('return');

              case 6:
                this.removeComponent(component, deepRemove);

              case 7:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function removeComponentById(_x10) {
        return _ref18.apply(this, arguments);
      }

      return removeComponentById;
    }()

    /**
     * remove all versions objects of the component from local scope.
     * if deepRemove is true, it removes also the refs associated with the removed versions.
     * finally, it removes the component object itself
     * it doesn't physically delete from the filesystem.
     * the actual delete is done at a later phase, once Repository.persist() is called.
     *
     * @param {ModelComponent} component
     * @param {boolean} [deepRemove=false] - whether remove all the refs or only the version array
     */

  }, {
    key: 'removeComponent',
    value: function removeComponent(component) {
      var deepRemove = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

      var repo = this.objects();
      (_logger || _load_logger()).default.debug(`sources.removeComponent: removing a component ${component.id()} from a local scope`);
      var objectRefs = deepRemove ? component.collectExistingRefs(repo, false).filter(function (x) {
        return x;
      }) : component.versionArray;
      objectRefs.push(component.hash());
      repo.removeManyObjects(objectRefs);
    }

    /**
     * merge the existing component with the data from the incoming component
     * here, we assume that there is no conflict between the two, otherwise, this.merge() would throw
     * a MergeConflict exception.
     */

  }, {
    key: 'mergeTwoComponentsObjects',
    value: function mergeTwoComponentsObjects(existingComponent, incomingComponent) {
      // the base component to save is the existingComponent because it might contain local data that
      // is not available in the remote component, such as the "state" property.
      var mergedComponent = existingComponent;
      // in case the existing version has is different than incoming version hash, use the incoming
      // version because we hold the incoming component from a remote as the source of truth
      Object.keys(existingComponent.versions).forEach(function (existingVersion) {
        if (incomingComponent.versions[existingVersion]) {
          mergedComponent.versions[existingVersion] = incomingComponent.versions[existingVersion];
        }
      });
      // in case the incoming component has versions that are not in the existing component, copy them
      Object.keys(incomingComponent.versions).forEach(function (incomingVersion) {
        if (!existingComponent.versions[incomingVersion]) {
          mergedComponent.versions[incomingVersion] = incomingComponent.versions[incomingVersion];
        }
      });
      return mergedComponent;
    }

    /**
     * Adds the objects into scope.object array, in-memory. It doesn't save anything to the file-system.
     *
     * When this function gets called originally from import command, the 'local' parameter is true. Otherwise, if it was
     * originated from export command, it'll be false.
     * If the 'local' is true and the existing component wasn't changed locally, it doesn't check for
     * discrepancies, but simply override the existing component.
     * In this context, "discrepancy" means, same version but different hashes.
     * When using import command, it makes sense to override a component in case of discrepancies because the source of
     * truth should be the remote scope from where the import fetches the component.
     * When the same component has different versions in the remote and the local, it merges the two
     * by calling this.mergeTwoComponentsObjects().
     */

  }, {
    key: 'merge',
    value: function () {
      var _ref19 = (0, (_bluebird || _load_bluebird()).coroutine)( /*#__PURE__*/(_regenerator || _load_regenerator()).default.mark(function _callee8(_ref20) {
        var component = _ref20.component,
            objects = _ref20.objects;
        var inScope = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
        var local = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
        var existingComponent, locallyChanged, mergedComponent, conflictVersions;
        return (_regenerator || _load_regenerator()).default.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                if (inScope) component.scope = this.scope.name;
                _context8.next = 3;
                return this._findComponent(component);

              case 3:
                existingComponent = _context8.sent;

                if (existingComponent) {
                  _context8.next = 6;
                  break;
                }

                return _context8.abrupt('return', this.put({ component, objects }));

              case 6:
                locallyChanged = existingComponent.isLocallyChanged();

                if (!(local && !locallyChanged || component.compatibleWith(existingComponent, local))) {
                  _context8.next = 11;
                  break;
                }

                (_logger || _load_logger()).default.debug(`sources.merge component ${component.id()}`);
                mergedComponent = this.mergeTwoComponentsObjects(existingComponent, component);
                return _context8.abrupt('return', this.put({ component: mergedComponent, objects }));

              case 11:
                conflictVersions = component.diffWith(existingComponent, local);
                throw new (_exceptions || _load_exceptions()).MergeConflict(component.id(), conflictVersions);

              case 13:
              case 'end':
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function merge(_x13) {
        return _ref19.apply(this, arguments);
      }

      return merge;
    }()
  }]);

  return SourceRepository;
}();

exports.default = SourceRepository;