'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = getMissingTestFiles;

var _ramda;

function _load_ramda() {
  return _ramda = _interopRequireDefault(require('ramda'));
}

var _isGlob;

function _load_isGlob() {
  return _isGlob = _interopRequireDefault(require('is-glob'));
}

var _fsExtra;

function _load_fsExtra() {
  return _fsExtra = _interopRequireDefault(require('fs-extra'));
}

var _path;

function _load_path() {
  return _path = require('./path');
}

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var DSL = ['{PARENT}', '{FILE_NAME}'];

function getMissingTestFiles(tests) {
  var missingTestFiles = [];
  var realTestFiles = tests.filter(function (testFile) {
    var files = DSL.filter(function (pattern) {
      return testFile.indexOf(pattern) > -1;
    });
    var glob = (0, (_isGlob || _load_isGlob()).default)((0, (_path || _load_path()).pathNormalizeToLinux)(testFile));
    return !glob && (_ramda || _load_ramda()).default.isEmpty(files) ? testFile : undefined;
  });
  if (!(_ramda || _load_ramda()).default.isEmpty(realTestFiles)) {
    missingTestFiles = realTestFiles.filter(function (testFile) {
      return !(_fsExtra || _load_fsExtra()).default.existsSync(testFile);
    });
  }
  return missingTestFiles;
}