'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = hasWildcard;
function hasWildcard(ids) {
  if (!ids) return false;
  if (Array.isArray(ids)) {
    return ids.some(function (id) {
      return idHasWildcard(id);
    });
  }
  return idHasWildcard(ids);
}

function idHasWildcard(id) {
  if (!id) return false;
  if (typeof id !== 'string') {
    throw new Error(`idHasWildcard expects id to be string, got ${typeof id}`);
  }
  return id.includes('*');
}