/** @flow */
import fs from 'fs-extra';
import { AUTO_GENERATED_STAMP, AUTO_GENERATED_MSG } from '../constants';

export type OutputFileParams = {
  filePath: string,
  content: string,
  writeAutoGeneratedMessage?: boolean,
  override?: boolean
};

export default (async function outputFile({
  filePath,
  content,
  writeAutoGeneratedMessage = true,
  override = true
}: OutputFileParams): Promise<string> {
  if (!override && fs.existsSync(filePath)) {
    const fileContent = fs.readFileSync(filePath).toString();
    if (!fileContent.includes(AUTO_GENERATED_STAMP)) return Promise.resolve(filePath);
  }

  const data = writeAutoGeneratedMessage ? AUTO_GENERATED_MSG + content : content;
  await fs.outputFile(filePath, data);
  return Promise.resolve(filePath);
});
